﻿using System;
using System.Collections.Generic;
using System.Linq;
using ArcToolkitCLI.Commands.Converters;
using CommandLine;

namespace ArcToolkitCLI.Commands
{
    [Verb("convert", HelpText = "Convert between common data types")]
    public class ConvertCommand : ICommand
    {
        public int Run()
        {
            var commandTypes = typeof(ConvertCommand).Assembly.GetTypes()
                .Where(t => !t.IsInterface && !t.IsAbstract && typeof(IConverterCommand).IsAssignableFrom(t)).ToArray();

            return new Parser(with =>
                {
                    with.IgnoreUnknownArguments = true;
                    with.HelpWriter = Parser.Default.Settings.HelpWriter;
                }).ParseArguments(Environment.GetCommandLineArgs().Skip(2), commandTypes)
                .MapResult((object t) => ((IConverterCommand)t).Run(), errs => 1);
        }
    }
}
